
package examenjava_2008_2009.gestionpoligonos;
import java.io.*;
import java.lang.*;
import java.util.*;

public class Gpoligono {
    
    public int nlados;
    public Punto [] v;
    public Rgb color;
    
    public Gpoligono(int np, Rgb c) throws IOException, ExceptionCreationGP
    {
        BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
        int x,y;
        if(np<=2)
        {    
             throw new ExceptionCreationGP("El númro de puntos no es correcto");
        }
        else
        {    
            this.color=c;
            this.nlados=np;
            this.v=new Punto[np];
            
            for(int indice=0;indice<np;indice++)
            {
                try
                {
                    System.out.println("Introduce Punto["+indice+"].x: ");
                    x =Integer.valueOf(in.readLine().trim()).intValue();
                    System.out.println("Introduce Punto["+indice+"].y: ");
                    y =Integer.valueOf(in.readLine().trim()).intValue();
                    this.v[indice]=new Punto(x,y); 
                }
                catch(Exception error)
                {
                    throw new ExceptionCreationGP("Valor incorrecto al construir uno de los puntos");
                }
            }            
        }
    }
    
    public int glados()
    {
        return this.v.length;
    }
    
    public Rgb getcolor()
    {
        return this.color;
    }
    
    public Punto getposicion_n(int p) throws ExceptionCreationGP
    {
        if (p<0 || p>=this.v.length)
        {    
             throw new ExceptionCreationGP("Se quiere devolver un punto que no existe");
        }
        return this.v[p];
    }
    
    public boolean compareTopoligonos(Gpoligono a)
    {
        int indice;
        if (a.nlados!=this.nlados || !a.color.compareToColor(this.color))
        {
            return false;
        }    
        for(indice=0;indice<this.nlados && this.v[indice].compareToPunto(a.v[indice]); indice++);
        if (indice!=this.v.length)
        {
            return false;
        }    
        return true;
    } 
}
