/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package examenjava_2008_2009.gestionviajes;

import examenjava_2008_2009.gestionpoligonos.ExceptionCreationGP;
import examenjava_2008_2009.gestionpoligonos.Punto;
import examenjava_2008_2009.gestionpoligonos.Rgb;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 *
 * @author Juan Antonio
 */
public class Viaje 
{
    public int ntra;
    public Trayectoria [] sectrayectos;
    
    public Viaje()
    {        
    }
    public Viaje(int num) throws IOException, ExceptionCreationGV
    {
        BufferedReader in=new BufferedReader(new InputStreamReader(System.in));
        String origen,destino;
        double distancia;
        if(num<1)
        {    
             throw new ExceptionCreationGV("El viaje no tiene sentido");
        }
        else
        {    
            this.ntra=num;
            this.sectrayectos=new Trayectoria[num];
            
            for(int indice=0;indice<num;indice++)
            {
                try
                {
                    System.out.println("Introduce Trayecto["+indice+"].origen: ");
                    origen =in.readLine().trim();
                    System.out.println("Introduce Trayecto["+indice+"].destino: ");
                    destino =in.readLine().trim();
                    System.out.println("Introduce Trayecto["+indice+"].distancia: ");
                    distancia =Double.valueOf(in.readLine().trim()).doubleValue();
                    this.sectrayectos[indice]=new Trayectoria(origen,destino,distancia); 
                }
                catch(Exception error)
                {
                    throw new ExceptionCreationGV("Error en los valores introducidos");
                }
            }            
        }
    }
    
    public Trayectoria mayortrayecto()
    {
        double mayor=Double.MIN_VALUE;
        Trayectoria m=null;
        
        for(int indice=0;indice<this.ntra;indice++)
        {
            if(this.sectrayectos[indice].distancia>mayor)
            {
                mayor=this.sectrayectos[indice].distancia;
                m=this.sectrayectos[indice];
            }
        }
        return(m);
    }     
    
    public double distanciaviaje()
    {
        double suma=0;
        
        for(int indice=0;indice<this.ntra;indice++)
        {
                suma+=this.sectrayectos[indice].distancia;
        }
        return(suma);
    }  
    
    public boolean combinables(Viaje v1)
    {
        if (this.sectrayectos[this.ntra-1].destino.compareToIgnoreCase(v1.sectrayectos[0].origen)==0)
        {
            return(true);
        }
        return (false);
    }

}
